<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_RelacionReferenciaProducto.xml */
/* Generado: 2024-08-07 06:49:08 */

/* Mantenimiento de los registros de la tabla MST_RelacionReferenciaProducto */
abstract class BaseMST_RelacionReferenciaProductoDP extends MST_RelacionReferenciaProductoBV
{
    /* Constructor ( Establece los valores desde un objeto MST_RelacionReferenciaProductoBN ) */
    public function __construct( MST_RelacionReferenciaProductoBN $o_MST_RelacionReferenciaProductoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN ) )
        {
            $this->setByBN( $o_MST_RelacionReferenciaProductoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_RelacionReferenciaProductoBN */
    public function setByBN( MST_RelacionReferenciaProductoBN $o_MST_RelacionReferenciaProductoBN )
    {
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdReleacion() ) )
        {
            $this->setIdReleacion( $o_MST_RelacionReferenciaProductoBN->getIdReleacion() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdReferencia() ) )
        {
            $this->setIdReferencia( $o_MST_RelacionReferenciaProductoBN->getIdReferencia() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdProveedor() ) )
        {
            $this->setIdProveedor( $o_MST_RelacionReferenciaProductoBN->getIdProveedor() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdColor() ) )
        {
            $this->setIdColor( $o_MST_RelacionReferenciaProductoBN->getIdColor() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdCatTalla() ) )
        {
            $this->setIdCatTalla( $o_MST_RelacionReferenciaProductoBN->getIdCatTalla() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdTalla() ) )
        {
            $this->setIdTalla( $o_MST_RelacionReferenciaProductoBN->getIdTalla() );
        }
        if ( !is_null( $o_MST_RelacionReferenciaProductoBN->getIdItem() ) )
        {
            $this->setIdItem( $o_MST_RelacionReferenciaProductoBN->getIdItem() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_RelacionReferenciaProductoFN = new MST_RelacionReferenciaProductoFN();
        $o_MST_RelacionReferenciaProductoBN = $o_MST_RelacionReferenciaProductoFN->selectByPk( $this->getIdReleacion() );
        if ( is_null( $o_MST_RelacionReferenciaProductoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_RelacionReferenciaProducto ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdReleacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdReleacion";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdReleacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdReferencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdReferencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdReferencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProveedor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProveedor";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProveedor()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdColor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdColor";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdColor()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCatTalla() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCatTalla";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCatTalla()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTalla() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTalla";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTalla()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_RelacionReferenciaProducto SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdReferencia() ) )
            {
                $s_SQLQuery .= $s_Separator."IdReferencia = ".$this->getIdReferencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProveedor() ) )
            {
                $s_SQLQuery .= $s_Separator."IdProveedor = ".$this->getIdProveedor()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdColor() ) )
            {
                $s_SQLQuery .= $s_Separator."IdColor = ".$this->getIdColor()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCatTalla() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCatTalla = ".$this->getIdCatTalla()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTalla() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTalla = ".$this->getIdTalla()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdReleacion = ".$this->getIdReleacion().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_RelacionReferenciaProducto WHERE  IdReleacion = ".$this->getIdReleacion().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>